/***************************************************************************
                          mymutex.h  -  description
                             -------------------
    begin                : Sun Jun 24 2001
    copyright            : (C) 2001 by Ruediger Knoerig
    email                : ruediger@knoerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MYMUTEX_H
#define MYMUTEX_H


/**simple QMutex replacement for Qt libs without thread support
  *@author Ruediger Knoerig
  */

class QMutex {
public: 
	QMutex() {locked = false; }
	~QMutex() {};
	/**
		* method for locking the mutex, does block!
		*/
	void lock() { while(locked); }
	/**
		* method for unlocking the mutex
		*/
	void unlock() { locked = false; }
	/**
		* getter for the status (!! not in original QMutex !! )
		* @return true if mutex is locked
		*/
	bool isLocked() { return locked; }
protected:
 bool locked;
};

#endif
