/***************************************************************************
                          voulumeimporter.h  -  description
                             -------------------
    begin                : Mon Jan 21 2002
    copyright            : (C) 2002 by Ruediger Knoerig
    email                : ruediger@knoerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VOULUMEIMPORTER_H
#define VOULUMEIMPORTER_H


/**base class for all voulume data importer
	* will import raw data
  	*@author Ruediger Knoerig
  	*/


class KURL;
class KvoulumeRendererDoc;
class QString;

class VoulumeImporter {
public:
	/**
		* default constructor
		* @param doc document object to work on
		*/
	VoulumeImporter(KvoulumeRendererDoc *doc); //  { docobj = doc; }
	/** default destructor */
	virtual ~VoulumeImporter() {}
	/** import method
		* @param url url of source to use
		* @param log will contain an operation log afterwards
		* @return true on success
		*/	
	virtual bool import(const KURL &url,QString &log);
protected:
	// pointer to the doc object to use
	KvoulumeRendererDoc *docobj;
};

#endif
