/***************************************************************************
                          voulumeimporterfactory.cpp  -  description
                             -------------------
    begin                : Mon Jan 21 2002
    copyright            : (C) 2002 by Ruediger Knoerig
    email                : ruediger@knoerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "voulumeimporterfactory.h"
#include "voulumeimporter.h"

VoulumeImporterFactory::VoulumeImporterFactory()
{
	/** build mimetypes map */
	mimetypes["raw"]=0;
	mimetypes[""]=0;
	/** build short description list */
	description += " raw data (*.raw)";
	/** create filter string from the description list and the mimetype map */
	// first entry for all supported files
   for(map<QString,unsigned int>::const_iterator it=mimetypes.begin();it != mimetypes.end(); ++it)
        {
                if(it->first.isEmpty())
                	{
                		filterstring += "* ";
                	}
                	else
                	{
                		filterstring += "*.";
                		filterstring += it->first;
                		filterstring += " ";
                	}
        }
 	filterstring += " | voulume files\n * | all files\n";
 	QStringList::Iterator s_it = description.begin();
	for(map<QString,unsigned int>::const_iterator it=mimetypes.begin();it != mimetypes.end(); ++it,s_it++)
        {
                filterstring += "*.";
                filterstring += it->first;
                filterstring += " | ";
                filterstring += *s_it;
                filterstring += "\n ";
        }	
}

VoulumeImporterFactory::~VoulumeImporterFactory(){
}

/** tries to produce a voulume importer from the given id */
VoulumeImporter * VoulumeImporterFactory::produce(unsigned int id,KvoulumeRendererDoc *docobj)
{
	switch(id)
	{
		case 0 : return new VoulumeImporter(docobj);
		default:  return new VoulumeImporter(docobj);
	};	
}

/* tries to produce a voulume importer from a given filename type extension */
VoulumeImporter *VoulumeImporterFactory::produce(QString typeextension,KvoulumeRendererDoc *docobj)
{
	map<QString,unsigned int>::iterator it = mimetypes.find(typeextension);
	if(it == mimetypes.end()) return new VoulumeImporter(docobj); // try raw file by default
	return VoulumeImporterFactory::produce(it->second,docobj);
}
