/***************************************************************************
                          zbuffer.cpp  -  description
                             -------------------
    begin                : Tue Jan 22 2002
    copyright            : (C) 2002 by Ruediger Knoerig
    email                : ruediger@knoerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "zbuffer.h"


/** No descriptions */
bool zbuffer::resize(int w,int h)
{
	if(depthbuffer) delete depthbuffer;
	depthbuffer = new double[w*h];
	if(smoothdepthbuffer) delete smoothdepthbuffer;
	smoothdepthbuffer = new double[w*h];
	if(depthbuffer && smoothdepthbuffer)
	{
		width = w;
		height = h;
		reset();
		return true;
	}
	else
	{
		 return false;
	}
}

/** method for doing the zBuffer test */
/*
bool zbuffer::drawPixel(int x,int y,double z)
{
	int offset =  x+y*width;
	double *ptr = &depthbuffer[offset];
	if(z <= *ptr)
	{
		// filter zbuffer
		*ptr = z;
		ptr = &smoothdepthbuffer[offset];
		double temp = 3 * z;
		temp += (ptr[-width-1] != MAXDOUBLE) ?  ptr[-width-1] : 0.0;
		temp += (ptr[-width] != MAXDOUBLE) ?  2*ptr[-width] : 0.0;
		temp += (ptr[-width+1] != MAXDOUBLE) ?  ptr[-width+1] : 0.0;
		temp += (ptr[-1] != MAXDOUBLE) ?  ptr[-1] : 0.0;		
		temp += (ptr[1] != MAXDOUBLE) ?  ptr[1] : 0.0;
		temp += (ptr[width-1] != MAXDOUBLE) ?  ptr[width-1] : 0.0;
		temp += (ptr[width] != MAXDOUBLE) ?  2*ptr[width] : 0.0;
		temp += (ptr[width+1] != MAXDOUBLE) ?  ptr[width+1] : 0.0;	
		*ptr = temp / 15.0;
		return true;
	}
	else
	{
		return false;
	}  		
}		

bool zbuffer::drawPixel(int offset ,double z)
{
	double *ptr = &depthbuffer[offset];
	if(z <= *ptr)
	{
		// filter zbuffer
		*ptr = z;
		ptr =   &smoothdepthbuffer[offset];
		double temp = 3 * z;
		temp += (ptr[-width-1] != MAXDOUBLE) ?  ptr[-width-1] : 0.0;
		temp += (ptr[-width] != MAXDOUBLE) ?  2*ptr[-width] : 0.0;
		temp += (ptr[-width+1] != MAXDOUBLE) ?  ptr[-width+1] : 0.0;
		temp += (ptr[-1] != MAXDOUBLE) ?  ptr[-1] : 0.0;		
		temp += (ptr[1] != MAXDOUBLE) ?  ptr[1] : 0.0;
		temp += (ptr[width-1] != MAXDOUBLE) ?  ptr[width-1] : 0.0;
		temp += (ptr[width] != MAXDOUBLE) ?  2*ptr[width] : 0.0;
		temp += (ptr[width+1] != MAXDOUBLE) ?  ptr[width+1] : 0.0;
		*ptr = temp / 15.0;
		return true;
	}
	else
	{
		return false;
	}  		
}
*/

/** calculate smoothed z-Buffer  */

void zbuffer::calcSmoothBuffer()
{
    double *ptr =  &depthbuffer[width+1];
    double *dst =  &smoothdepthbuffer[width+1];
    double temp;
    for(int i=0; i < width*(height-2)-2; i++)
    {
		temp = (ptr[i] != MAXDOUBLE) ? ptr[i] : 0.0;
		temp += (ptr[i-width-1] != MAXDOUBLE) ?  ptr[i-width-1] : 0.0;
		temp += (ptr[i-width] != MAXDOUBLE) ?  ptr[i-width] : 0.0;
		temp += (ptr[i-width+1] != MAXDOUBLE) ?  ptr[i-width+1] : 0.0;
		temp += (ptr[i-1] != MAXDOUBLE) ?  ptr[i-1] : 0.0;		
		temp += (ptr[i+1] != MAXDOUBLE) ?  ptr[i+1] : 0.0;
		temp += (ptr[i+width-1] != MAXDOUBLE) ?  ptr[i+width-1] : 0.0;
		temp += (ptr[i+width] != MAXDOUBLE) ?  ptr[i+width] : 0.0;
		temp += (ptr[i+width+1] != MAXDOUBLE) ?  ptr[i+width+1] : 0.0;
		if(temp) dst[i] = temp / 9.0;
	}
}
